int g;
List<int> map(func<int, int> f, List<int> list) {
    List<int> out = [0]; 
        
    for x in list {
        append(out, f(x));
    }
    return out[1:-1];
}

List<int> filter(func<bool, int> f, List<int> list) {
    List<int> out = [0]; 
        
    for x in list {
        if (f(x)) {
            append(out, x);
        }
    }
    return out[1:-1];
}

func<int, int> sum2() {
    return int lambda int x -> x+2;
}


int main()
{
    List<int> my_list = range(5);
    func<void, List<int>> print_list = void lambda List<int> list {
        for x in list {
            print(x);
        }
    };

    g = 2;
    List<int> out = map(int lambda int x { return x*g; }, my_list);
    print_list(out);
    out = map(int lambda int x -> x*2, my_list);
    print_list(out);
    out = map(sum2(), my_list);
    print_list(out);
    out = filter(bool lambda int x -> x > 2, my_list);
    print_list(out);
    return 0;
}